<template>
    <div class="payform" ref="payform">
        <ui-card :class="{success: step === 4, error: step === 5}" >
            <ui-card-header v-if="title">
                {{title}}
            </ui-card-header>
            <ui-card-body>
                <component :is="stepComponent"

                           @cancel="cancelHandler"
                           @success-pay="successPay"
                           @error-pay="errorPay"

                           @payButtonPress="payButtonPress"
                           @setMethod="setPaymentMethod">
                </component>
            </ui-card-body>
            <ui-card-footer center v-if="backText">
                <ui-button link bold @click="back">
                    {{backText}}
                </ui-button>
            </ui-card-footer>

            <ui-card-footer v-if="step === 4" center>
                <div class="coupons-action" :class="{ bottom: $interface.isMobile}">
                    <p>
                        Вам доступны персональные купоны со скидками. Хотите
                        принять участие в акциях и сэкономить на покупках?
                    </p>
                    <ui-button color="red" center>
                        Получить скидки
                    </ui-button>
                </div>
            </ui-card-footer>

            <ui-card-footer v-if="step === 5" center>
                    <ui-row>
                        <ui-col :xs="24" :md="12">
                            <ui-button link center @click="step = 1">
                                Выбрать другой способ
                            </ui-button>
                        </ui-col>
                        <ui-col :xs="24" :md="12" >
                            <ui-button color="red" center @click="step = 3">
                                Оплатить другой картой
                            </ui-button>
                        </ui-col>
                    </ui-row>
            </ui-card-footer>

<!--            <ui-card-expand>-->
<!--                <payment-checkbox-list @set-sales="updateSelectedPosItems"></payment-checkbox-list>-->
<!--            </ui-card-expand>-->
        </ui-card>

    </div>
</template>

<script>
    import SelectPayMethod from './steps/SelectPayMethod';
    import PaymentData from './steps/PaymentData';
    import PaymentSuccess from './steps/Success';
    import PaymentError from './steps/Error';
    import {icon, methods} from './common/methods';
    import PaymentCheckboxList from '@/pages/POS/components/payment-checkbox-list';
    import {mapGetters} from 'vuex';

    import Card from '@/components/PayForm/methods/card';
    import MethodSberbank from '@/components/PayForm/methods/Sberbank';
    import MethodYandex from '@/components/PayForm/methods/YandexWallet';
    import MethodQiwi from '@/components/PayForm/methods/Qiwi';
    import MethodMKB from '@/components/PayForm/methods/Mkb';
    import MethodElecsnet from '@/components/PayForm/methods/ElexNet';
    import MethodRussianPost from '@/components/PayForm/methods/RussianPost';
    import MethodRuRu from '@/components/PayForm/methods/RuRu';
    import MethodBankTransfer from '@/components/PayForm/methods/BankTransfer';
    import MethodGoldCrow from '@/components/PayForm/methods/GoldCrown';
    // import MethodContact from '@/components/PayForm/methods/'
    // import MethodSvyaznoy from '@/components/PayForm/methods/'

    const steps = {
        1: 'Способ оплаты',
        2: 'Укажите сумму вносимого платежа',
        3: 'Введите данные'
    };

    const backText = {
        1: 'Вернуться на экран займа',
        2: 'Другой способ погашения',
        3: 'Изменить сумму оплаты'
    };



    export default {
        name: 'component-pay-form',
        components: {
            card: Card,
            PaymentCheckboxList,
            sberbank: MethodSberbank,
            yandex: MethodYandex,
            qiwi: MethodQiwi,
            mkb: MethodMKB,
            elecsnet: MethodElecsnet,
            russian_post: MethodRussianPost,
            ruru: MethodRuRu,
            bank_transfer: MethodBankTransfer,
            gold_crown: MethodGoldCrow,
            // contact: MethodContact,
            // svyaznoy: MethodSvyaznoy
        },
        data () {
            return {
                step: 2,
                method: '',
            }
        },

        props: {
            createHandler: {
                required: false,
                type: Function,
            }
        },

        watch: {
            method(method) {
                if (method) {
                    this.step = 2;
                }

                this.$store.state.payment.selectedPaymentMethod = method;

            },

            step () {
                console.trace('PayForm::step', this.step);
                this.$nextTick(() => {
                    this.$helpers.scroll(this.$refs.payform);
                })
            }
        },

        computed: {
            operations () {
                return this.$POS.schedule.sort((a, b) => {
                    return new Date(a.date).getTime() - new Date(b.date).getTime();
                }).map((schedule) => {
                    const goods = [];
                    schedule.products.forEach((product) => {
                        goods.push(product);
                    })

                    return goods;
                })
            },

            methodIcon () {
                return this.method ? icon[this.method] : '';
            },
            title () {
                if (this.method) {
                    return `Оплата ${methods[this.method]}`
                } else if (!this.method && this.step === 2) {
                    return `Оплата картой`;
                }

                return steps[this.step];
            },

            stepComponent () {
                switch(this.step) {
                    case 1: return SelectPayMethod;
                    case 2: return PaymentData;
                    case 3: return this.$options.components[this.method];
                    case 4: return PaymentSuccess;
                    case 5: return PaymentError;
                    default: return SelectPayMethod;
                }
            },

            backText () {
                if (this.$interface.viewport === 'mobile' && this.step === 2) {
                    return 'Другой способ оплаты';
                } else {
                    return backText[this.step];
                }
            },
            ...mapGetters(['$POS'])
        },

        created () {
            console.log('createHandler = ', typeof this.createHandler);
            if(typeof this.createHandler === "function") {
                console.log('PayForm::createHandler');
                this.createHandler();
            }
            this.$store.commit('PAYMENT_IN_PROCESS', true);

            if(this.step === 2) {
                this.method = 'card';
            }
        },

        mounted () {
            this.$helpers.scroll(this.$refs.payform);
        },

        beforeDestroy () {
            this.$store.commit('PAYMENT_IN_PROCESS', false);
        },

        methods: {
            setMethod (method) {
                console.log('setMethod', method);
                this.method = method;
            },

            back () {
                console.log('PayForm::index.back()', this.step);
                if(this.step >= 2) {
                    this.step -= 1;
                    if(this.step === 1) {
                        this.method = '';
                    }
                    console.log('set step', this.step);
                } else {
                    this.method = '';
                    console.log('PayForm::index.back() - close form');
                    this.$emit('back')
                }
            },

            payButtonPress () {
                this.step = 3;
            },

            updateSelectedPosItems (list) {
                this.$store.commit('SET_PAYMENT', {
                    data: {
                        ids: list.filter(sale => sale.selected)
                    }
                })
            },

            cancelHandler () {
                this.$emit('back')
            },

            setPaymentMethod (method) {
                this.method = method;
                this.$forceUpdate();
            },

            successPay () {
                this.method = '';
                this.step = 4;
            },

            errorPay () {
                this.step = 5;
            }
        }
    };
</script>
